#include "AGVController.h"
#include "../StateMachine/smutil.h"


using namespace std;


namespace in
{
	STATIC_CONST_STRING( AGV_OUT_START );
	STATIC_CONST_STRING( AGV_OUT_STOP );
	
	STATIC_CONST_STRING( AGV_HOME_START );
	STATIC_CONST_STRING( AGV_HOME_STOP );

};

namespace out
{
	STATIC_CONST_STRING( AGV_OUT_ARRIVED );
	STATIC_CONST_STRING( AGV_OUT_ERROR );
	STATIC_CONST_STRING( AGV_OUT_STOPPED );

	STATIC_CONST_STRING( AGV_HOME_ARRIVED );
	STATIC_CONST_STRING( AGV_HOME_ERROR );
	STATIC_CONST_STRING( AGV_HOME_STOPPED );
};


int AGVController::activate()
{
	wait_for_outward = wait_for_homeward = false;
	return 0;
}


int AGVController::process()
{
	// ԋ@B̓`FbN
	if( m_inputIn.isNew() ) {	
		m_inputIn.read();

		// 擪"AGV"łȂȂΏł؂
		if( !smutil::checkPrefix( m_input.data[0], "AGV" ) )
			return 0;

		string input = m_input.data[0];
		string output = "";

		if( input != "" ) {
			cout << ">> " << input << endl;
		}

		// ͂ɑ΂鏈
		if( input == in::AGV_OUT_STOP ) {
			output = out::AGV_OUT_STOPPED;
		}
		else if( input == in::AGV_HOME_STOP ) {
			output = out::AGV_HOME_STOPPED;
		}
		else if( input == in::AGV_OUT_START ) {
			/* HJn */
			m_toPlanner.data = "ROBOT_START";
			wait_for_outward = rtcutil::write( m_toPlannerOut );

			// PathPlannerRTCɂȂĂȂꍇ
			if( !wait_for_outward ) {
#				if 1
				output = out::AGV_OUT_ERROR;
#				else
				// 쌟ؗp_~[
				output = out::AGV_OUT_ARRIVED;
#				endif
			}

		}
		else if( input == in::AGV_HOME_START ) {
			/* HJn */
			m_toPlanner.data = "ROBOT_GO_BACK";
			wait_for_homeward = rtcutil::write( m_toPlannerOut );

			// PathPlannerRTCɂȂĂȂꍇ
			if( !wait_for_homeward )
#				if 1
				output = out::AGV_HOME_ERROR;
#				else
				// 쌟ؗp_~[
				output = out::AGV_HOME_ARRIVED;
#				endif
		}

		if( output != "" ) {
			/* o͂ωĂCɃ|[gɏo */
			cout << "<< " << output << endl;
			smutil::write( output, m_output, m_outputOut );
		}

	}

	/* HEHҋ@ */
	if( wait_for_outward || wait_for_homeward ) {
		// PathPlannerRTC̓͂
		if( m_fromPlannerIn.isNew() ) {
			m_fromPlannerIn.read();
			
			string output = "";
			if( wait_for_outward /*&& !strcmp( m_fromPlanner.data, "???" ) )*/ ) {
				output = out::AGV_OUT_ARRIVED;
				wait_for_outward = false;
			}
			if( wait_for_homeward /*&& !strcmp( m_fromPlanner.data, "???" ) )*/ ) {
				output = out::AGV_HOME_ARRIVED;
				wait_for_homeward = false;
			}

			if( output != "" ) {
				cout << "<< " << output << endl;

				/* o͂ωĂ͂Ȃ̂ŁC|[gɏo */
				smutil::write( output, m_output, m_outputOut );
			}
		}
	}

	return 0;
}