#include "HiroGateRTCSVC_impl.h"
#include <cmath>
#include <fstream>
#include <string>
#include "../VSCommon/system/misc/misc.h"
#include "hgutil.h"


#if defined( _V0514_2 ) || defined( _V0514_5 ) || defined( _V0514_6 )
using namespace ikfast;
using namespace opencv;
using namespace std;
#endif


/*=========================================================
	w̎w
=========================================================*/
CORBA::Long HiroGateServiceSVC_impl::setFingerDistanceL(
	CORBA::Double distance_l_mm, 
	CORBA::Double t, CORBA::Boolean wait_for_motion)
{
  return setFingerDistance( "LHAND", distance_l_mm, t, wait_for_motion );
}
CORBA::Long HiroGateServiceSVC_impl::setFingerDistanceR(
	CORBA::Double distance_r_mm, 
	CORBA::Double t, CORBA::Boolean wait_for_motion)
{
  return setFingerDistance( "RHAND", distance_r_mm, t, wait_for_motion );
}


/*=========================================================
	setFingerDistanceL/R()̋ʕ
=========================================================*/
long HiroGateServiceSVC_impl::setFingerDistance(
	const char *hand_name, double distance_mm, 
	double t, bool wait_for_motion )
{
	if( CORBA::is_nil( svc_ptrs.gs_if->getObject() ) )
		return 0x80000000;

	OpenHRP::GrasperService::DblSequence angles_rad;
	angles_rad.length(4);
	if( convertFingerDistanceToFingerAngles( distance_mm, angles_rad ) )
		return -2;

	CORBA::Double ttm;
	(*svc_ptrs.gs_if)->setJointAngles( hand_name, angles_rad, t, ttm );

	if( wait_for_motion )
		(*svc_ptrs.gs_if)->isEmpty( 0x1F, true );
	
	return 0;
}


/*=========================================================
=========================================================*/
CORBA::Long HiroGateServiceSVC_impl::setFingerDistanceLR(
	CORBA::Double distance_l_mm, CORBA::Double distance_r_mm, 
	CORBA::Double t, CORBA::Boolean wait_for_motion)
{
	int res_l, res_r;

	/* ^CO̍팸̂߂ɐɊpxvZ */
	OpenHRP::GrasperService::DblSequence angles_l_rad, angles_r_rad;
	angles_l_rad.length(4);
	angles_r_rad.length(4);
	
	res_l = convertFingerDistanceToFingerAngles( distance_l_mm, angles_l_rad );
	res_r = convertFingerDistanceToFingerAngles( distance_r_mm, angles_r_rad );
	
	if( res_l || res_r )
		return -100;

	CORBA::Double ttm;
	(*svc_ptrs.gs_if)->setJointAngles( "LHAND", angles_l_rad, t, ttm );
	(*svc_ptrs.gs_if)->setJointAngles( "RHAND", angles_r_rad, t, ttm );

	// ҂
	while( wait_for_motion && (isFingerMovingL() || isFingerMovingR()) )
		Sleep(50);
	
  return 0;
}