#pragma once


#include "../VSCommon/opencv/cvutil/cvutil.h"
#include "../VSCommon/opencv/cvmath/cvmath.h"
#include "../HiroGate/hgutil.h"
#include "HiroGateRTCStub.h"
#include "../VSCommon/system/thread/thread.h"
#include "../VSCommon/system/crtsec/crtsec.h"


namespace pnp
{

	/********************************************************
		RtBM[Vp[^
	********************************************************/
	struct configuration_parameter_t
	{
		/* EW */
		opencv::cvmath::Vector< CV_64F > worldR_m;
		double worldR_deg;

		/* ̂ */
		opencv::cvmath::Vector< CV_64F > xy_ope_offsetR_m;

		/* 쑬x */
		double speed_base;

		/* eHIROŗLւ̕pVAio[ */
		long serial_no;

		double hold_distance_m;				// ̂͂ނƂ̎̋ߕ
		double release_distance_m;		// ̂𗣂Ƃ̎̍L

		double finger_backlash_deg;		// w摤̊֐߂̗Vъp

		/* pbg̃p[^ */
		struct pallet_param_t
		{
			double width_m;								// 
			double height_m;							// 
			double bottom_height_m;				// ʂ̏ʂ̍
			double hole_bottom_height_m;	// ̉ӂ̍
			double width_k;								// ̒

			// pbguꏊ(̍WnB)
			opencv::cvmath::Vector< CV_64F > xyz_placedB_m;
			opencv::cvmath::Vector< CV_64F > rpy_placedB_deg;

			// pbgu
			double direction_placedR_deg;

			// tg
			double lift_distance_R_m;

			// pbguꏊ(̍WnB)
			opencv::cvmath::Vector< CV_64F > xyz_to_be_placedB_m;
			opencv::cvmath::Vector< CV_64F > rpy_to_be_placedB_deg;

			// pbgu
			double direction_to_be_placedR_deg;

			// Xbgʒu(pbgWnP)
			opencv::cvmath::Vector< CV_64F > xy_slotP_abs_m;

			// uꏊ`
			enum slot_u_t
			{
				CUBOID = 0, CYLINDER = 1 
			};
			
			// 2x2摜3`lxyzƂėp
			opencv::cvutil::Image< IPL_DEPTH_64F > placing_slotB;

		public:
			pallet_param_t()
				: xyz_placedB_m( 3 ),     rpy_placedB_deg( 3 ),
				xyz_to_be_placedB_m( 3 ), rpy_to_be_placedB_deg( 3 ),
				xy_slotP_abs_m( 2 )
			{
				/* Ô߂̕Wp[^ݒ */

				width_m = 0.30;
				height_m = 0.085;
				bottom_height_m = 0.007;
				hole_bottom_height_m = 0.045 + 0.005;
				width_k = 0.02;


				xyz_placedB_m(0) = +0.470;
				xyz_placedB_m(1) = +0.000;
				xyz_placedB_m(2) = +0.015;

				rpy_placedB_deg(0) = +0.00;
				rpy_placedB_deg(1) = -90.0;
				rpy_placedB_deg(2) = +0.00;
		

				direction_placedR_deg = -90;

				lift_distance_R_m = 0.15;


				xyz_to_be_placedB_m(0) = +0.470;
				xyz_to_be_placedB_m(1) = +0.000;
				xyz_to_be_placedB_m(2) = +0.032;

				rpy_to_be_placedB_deg(0) = +0.00;
				rpy_to_be_placedB_deg(1) = -90.0;
				rpy_to_be_placedB_deg(2) = +0.00;
				
				
				direction_to_be_placedR_deg = 0.0;

				xy_slotP_abs_m(0) = 0.08/2;
				xy_slotP_abs_m(1) = 0.0795/2;

			}

			double hold_width_m() const
			{ return width_m - width_k;	}

			int findEmptyPlacingSlot( int model_id, RTC::Point3D &slot_xyzB_m );

		} pallet;
	public:
		configuration_parameter_t()
			: worldR_m( 3 ), xy_ope_offsetR_m( 2 )
		{
			/* Ô߂̕Wp[^ݒ */

			worldR_m(0) = +0.350;
			worldR_m(1) = -0.096;
			worldR_m(2) = +0.032;

			worldR_deg = 0.0;
			
			xy_ope_offsetR_m(0) = 0.0;
			xy_ope_offsetR_m(1) = 0.0;

			speed_base = 5;

			serial_no = 3;

			hold_distance_m = 0.001;
			release_distance_m = 0.002;

			finger_backlash_deg = 8;

		}
		
		double t_s()
		{
			if( speed_base < 5 )	return 8;
			if( 30 < speed_base )	return 2;
		
			const double x0 = 5, y0 = 8;
			const double x1 = 30, y1 = 2;
			const double a = (y1 - y0) / (x1 - x0);
			const double b = y0 - a*x0;

			return a * speed_base + b;
		}


	};


	/**********************************************************
		pf[^
	**********************************************************/
	struct operation_t
	{
	public: // p֘Af[^
		static bool pose_initialized;

		// ֐ߊp
		static HiroGateRTC::HiroGateService::JointAngles pose_all_initial;
		static HiroGateRTC::HiroGateService::JointAngles pose_torso_only;
		static HiroGateRTC::HiroGateService::JointAngles pose_arm_initial;
		
		// w֐ߊp
		static HiroGateRTC::HiroGateService::FingerAngles fL_pallet_open;
		static HiroGateRTC::HiroGateService::FingerAngles fR_pallet_open;
		static HiroGateRTC::HiroGateService::FingerAngles f_close;//f_3cm_close;
		
		//static opencv::cvmath::Matrix< CV_64F > R_WtoR;

	public: // 쐧֘Af[^
		static sys::Thread thread;
		
		//static sys::CriticalSection cs;
		
		// 쒆tO
		static bool in_obj_manip, in_tray_manip;
		
		// Xbh~pLXCb`(݂̓Xbh~pƂĂ͖gp)
		static bool kill_switch;

		// HIROڑ
		static bool is_hiro_connected;

		// o
		static std::string input, output;
	
	public: // ʒupvZpf[^
		double torso_angle_rad;

		hgutil::dominant_side_t side;
		RTC::Pose3D B, R;

	public:
		// ř
		void decideDominantSide( const RTC::Pose3D &poseR )
		{
			side = hgutil::decideDominantSide( poseR.position, torso_angle_rad );
		}


		// \
		void print() const
		{
			using std::cout;
			using std::endl;

			cout << "side        : " << ( side == hgutil::LEFT ? "LEFT" : "RIGHT" ) << endl;
			cout << "torso angle : " << opencv::cvmath::rad2deg( torso_angle_rad ) << endl;
			cout << "poseR       : ";	hgutil::printPose3D( R );
			cout << "poseB       : ";	hgutil::printPose3D( B );
		}

	};

} // namespace pnp

