#include "ObjectPoseEstimationGateRTCSVC_impl.h"


using namespace opencv;


/**
	̈ʒupRTC畨IDƈʒup擾ăT[rXɕێ
*/
void ObjectPoseEstimationGateServiceSVC_impl::setEstimatedResult(
	int id, const RTC::Pose3D& poseW_m_rad )
{
	this->id = id;
	this->pose = poseW_m_rad;
}


/**
	T[rXɕێĂ镨IDƈʒupNA
*/
void ObjectPoseEstimationGateServiceSVC_impl::resetEstimatedResult()
{
	id = -1;
	pose.position.x = pose.position.y = pose.position.z = 0.0;
	pose.orientation.y = pose.orientation.p = pose.orientation.r = 0.0;
}


/**
	EnW烍{bgnRւ̕ϊ
*/
void ObjectPoseEstimationGateServiceSVC_impl::W2R(
		const cvmath::Matrix< CV_64F > &R_WtoR, const cvmath::Vector< CV_64F > &t_WtoR,
		const RTC::Pose3D &pose_objW,
		cvmath::Vector< CV_64F > &p_objR, cvmath::Matrix< CV_64F > &R_objR )
{
	
	// ̂̈ʒu(W: En, R: {bgn)
	cvmath::Vector< CV_64F > p_objW(3);
	p_objW(0) = pose_objW.position.x;
	p_objW(1) = pose_objW.position.y;
	p_objW(2) = pose_objW.position.z;

	//cout << "W2R::p_objW="; p_objW.print();

	p_objR.MxV( R_WtoR, p_objW );
		// ]

	//cout << "W2R::p_objW="; p_objR.print();

	p_objR(0) += t_WtoR(0);
	p_objR(1) += t_WtoR(1);
	p_objR(2) += t_WtoR(2);
		// sړ

	// ̂̎p(W: En, R: {bgn)
#	if 1
	cvmath::RotationManager< CV_64F > rm;
	const cvmath::Matrix< CV_64F > &R_objW = 
		rm.getRzyxEuler(
			pose_objW.orientation.y, 
			pose_objW.orientation.p, 
			pose_objW.orientation.r );
#	else
	cvmath::Matrix< CV_64F > R_objW(3,3);
	cvmath::Quaternion< CV_64F > q[3], qtmp, qxyz;
	cvmath::Vector< CV_64F > axis(3);
	axis.setZero();	axis(0) = pose_objW.orientation.r;	q[0].fromAxis( axis );
	axis.setZero();	axis(1) = pose_objW.orientation.p;	q[1].fromAxis( axis );
	axis.setZero();	axis(2) = pose_objW.orientation.y;	q[2].fromAxis( axis );
	qtmp.QxQ( q[0], q[1] );
	qxyz.QxQ( qtmp, q[2] );
	qxyz.toR( R_objW );
		// EWn̉]s
#	endif

	R_objR.MxM( R_WtoR, R_objW );
		// Enł̉]s{bgnɕϊ
}


/**********************************************************
	̂͂ނ̂ɕKvȃp[^߂
**********************************************************/
void ObjectPoseEstimationGateServiceSVC_impl::calculateCuboidPickingParameter(
	const ModelDefinitionRTC::idl::ObjectModel &cuboid_mdl,
	const cvmath::Matrix< CV_64F > &R_objR, 
	double *width_m, double *height_m, double *yaw_rad )
{
	// f`xNg
	opencv::cvmath::Vector< CV_64F > cuboid_m[3];
	for( int i = 0; i < 3; ++ i ) {
		cuboid_m[i].resize( 3 );
		cuboid_m[i].setZero();
	}
#	ifdef OPEG_USE_COMMON_IF
	cuboid_m[0](0) = cuboid_mdl.wx;	// X
	cuboid_m[1](1) = cuboid_mdl.wy;	// Y
	cuboid_m[2](2) = cuboid_mdl.wz; // Z
#	else
	cuboid_m[0](0) = 0.040/2;	// X
	cuboid_m[1](1) = 0.030/2;	// Y
	cuboid_m[2](2) = 0.050/2; // Z
#endif

	// ]f̃xNgƊ̖@xNg̊px
	cvmath::Vector< CV_64F > Rcuboid[3];
	for( int i = 0; i < 3; ++ i ) {
		Rcuboid[i].resize( 3 );
		Rcuboid[i].setZero();
	}

	cvmath::Vector< CV_64F > z( 3 );
	z.setZero();
	z(2) = 1;
	int vertical_axis_idx = 0;
	double cos_abs, max_cos_abs = -1;

	for( int axi = 0; axi < 3; ++axi ) {
		//(a,b) = |a||b|cos
		//cos = (a,b)/(|a||b|)
		Rcuboid[axi].MxV( R_objR, cuboid_m[axi] );
		cos_abs = fabs( Rcuboid[axi].dotV( z )/(Rcuboid[axi].norm()*z.norm()) );
		//printf( "\t|cos| = %f\n", cos_abs );

		if( max_cos_abs < cos_abs )
			max_cos_abs = cos_abs, vertical_axis_idx = axi;
	}
	printf( "\tvertical axis index = %d\n", vertical_axis_idx );

	// (=x-yʁCɕs)̒ӂ̊px𒲂ׂ
	int top_surface_idx[2] = {};
	int idx_cnt = vertical_axis_idx + 1;
	// vertical_axis_idx == 0  idx_cnt = 1, 2;
	// vertical_axis_idx == 1  idx_cnt = 2, 0;
	// vertical_axis_idx == 2  idx_cnt = 0, 1;
	for( int tsi = 0; tsi < 2; ++ tsi ) {
		idx_cnt = idx_cnt % 3;
		top_surface_idx[tsi] = idx_cnt ++;
		//printf("\ttop surface [%d] = %d\n", tsi, top_surface_idx[tsi] );
	}

	// top_surface_idxɓo^ꂽӂ̂ق
	int longer_edge_idx, shorter_edge_idx;
	longer_edge_idx = 
		(cuboid_m[ top_surface_idx[0] ].norm() > cuboid_m[ top_surface_idx[1] ].norm()) ? 
		top_surface_idx[0] : top_surface_idx[1];
	shorter_edge_idx = 
		(cuboid_m[ top_surface_idx[0] ].norm() < cuboid_m[ top_surface_idx[1] ].norm()) ? 
		top_surface_idx[0] : top_surface_idx[1];
	printf( "\tlonger edge of top surface: %d (%fm)\n", longer_edge_idx, cuboid_m[longer_edge_idx].norm() );

	int temp = longer_edge_idx;
	longer_edge_idx = shorter_edge_idx;
	shorter_edge_idx = temp;

	// longer_edge_idx ̕ӂx-yʂ̊px
	double yaw = atan2( Rcuboid[ shorter_edge_idx ](1), Rcuboid[ shorter_edge_idx ](0) );
	printf( "\tyaw = %f[deg]\n", cvmath::rad2deg( yaw ) );
	
	// HIRO͂߂pxɏC
	double yaw_abs = fabs( yaw );
	if( cvmath::deg2rad( 90 ) < yaw_abs ) {
		// -180 ` -90
		// +180 ` +90
		yaw += -(yaw_abs/yaw) * M_PI;
	}

	//-0.037, -0.063, 0.072, 0.017

	*width_m = 2 * cuboid_m[longer_edge_idx].norm();
	*height_m = 2 * cuboid_m[vertical_axis_idx].norm();
	*yaw_rad = yaw;
}


/**********************************************************
	~͂ނ̂ɕKvȃp[^߂
	iModelDefinitionRTCObjPoseEstimationCommanderɐڑĂȂ̂Ń_~[j
**********************************************************/
void ObjectPoseEstimationGateServiceSVC_impl::calculateCylinderPickingParameter( 
	const ModelDefinitionRTC::idl::ObjectModel &cylinder_mdl,
	double *width_m, double *height_m, double *yaw_rad )
{

#	ifdef OPEG_USE_COMMON_IF

	*width_m = 2 * cylinder_mdl.radius;
	*height_m = 2 * cylinder_mdl.height;
	*yaw_rad = 0;

#	else
	// f`
	struct cylinder_t
	{
		// a[m], [m]
		double r_m, h_m;
	} cylinder;

	cylinder.r_m = 0.015;
	cylinder.h_m = 0.030;
	
	*width_m = 2 * cylinder.r_m;
	*height_m = 2 * cylinder.h_m;
	*yaw_rad = 0;

#endif

}
