// ================================================================================== //
// Name of File				: base_data.h
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#ifndef _BASE_DATA__
#define _BASE_DATA__

#define TAKE_VIDEO get_video
#define __SOUND
//#define ___DEBUG_FILE___
#define __CONFIGURATION_DEFINE__


#ifndef __CONFIGURATION_DEFINE__
#define Wheel_Tread (332.5)//tread mm
#define ACCEL_CONSTRAINT (400)//(600)//accelerationFmm/s^2
#define RAD_CONSTRAINT 3201
#define MAX_CONSTRAINT (600)
#else
#define Wheel_Tread tread//Wheel treadiunitFmmj
#define ACCEL_CONSTRAINT robot_acc//(600)//Acceleration limit.unitFmm/s^2
#define RAD_CONSTRAINT 3201
#define MAX_CONSTRAINT robot_max
#endif

#define RAD_to_DEG (180.0/PI)
#define DEG_to_RAD (PI/180.0)
#define ABS(x) ((x) > 0 ? (x):-(x))
#ifndef PI
#define PI (3.1415926)
#endif

#define FP_TEST (1)//For creating a thesis presentation. (1) If you create a node_num.txt. The number of nodes created, which contains the number of nodes on average.
#define BEST_PATH_SEARCH (1)//Whether the best-first path search

#include <stdio.h>
#include "../VSCommon/opencv/cvutil/cvutil.h"
//#include <opencv/cv.h>
//#include <opencv/cxcore.h>
//#include <opencv/highgui.h>
#include <vector>
#include <mmsystem.h>

/*Character buffer size*/
#define BUF (256)

class IMAGE_LIST{
public:
	IplImage *save_image;
	IMAGE_LIST *next;
	//IMAGE_LIST(IplImage *image);//constructor
	void MakeList(IplImage *image);
	void ClearList(IMAGE_LIST *pointer);
};

class IMAGE_STORE : public IMAGE_LIST{//Inheritance
public:
	char file_name[BUF];
	int image_num;
	IMAGE_LIST *end_pointer;
	IMAGE_LIST *start_pointer;
	IMAGE_LIST *now_pointer;
	IMAGE_STORE(void);//Constructor 1
	~IMAGE_STORE(void);//Destructor
	void DiscribeImage(char *name);//Accumulated data released to the outside
	void SaveImage(IplImage *image);
	void Reset(void);
};


#ifdef __MAIN__
int consumption_memory_size = 0;
double exec_Hz;
//Configuration global variable declaration
std::string motion_file_name;
double tread;//wheel radius(mm)
double loopTime;//loop time(sec)
double timeOut_s;//time out(msec)
int goalAreaRadius;//goal area(mm)
int moveObjeRadius;//radius of moving object(mm)
double robot_acc;//robot acc(mm/sec^2)
double robot_dec;//robot dec(mm/sec^2)
int robotRadius;
int sound_set;
DWORD loopTimer;
int img_transfer;
float robot_to_target_distance_warning_threshold;
int use_waypoint_port;
int use_localization_port;
int use_people_tracking_port;
int use_waypoint_heading;
int use_map_service;
int use_people_service;
bool get_video;
double robot_max;
std::string message;
#else
extern double exec_Hz;
extern DWORD loopTimer;
extern int consumption_memory_size;
//Configuration global variable declaration
extern std::string motion_file_name;
extern double tread;//wheel(mm)
extern double loopTime;//Loop time(sec)
extern double timeOut_s;//time_out(msec)
extern int goalAreaRadius;//goal area(mm)
extern int moveObjeRadius;//radius of moving object(mm)
extern double robot_acc;//robot acc(mm/sec^2)
extern double robot_dec;//robot dec(mm/sec^2)
extern int robotRadius;
extern int sound_set;
extern int img_transfer;
extern float robot_to_target_distance_warning_threshold;
extern int use_waypoint_port;
extern int use_localization_port;
extern int use_people_tracking_port;
extern int use_waypoint_heading;
extern int use_map_service;
extern int use_people_service;
extern bool get_video;
extern double robot_max;
extern std::string message;
#endif
using namespace std;

//For warning_flag.
#define COLLISION			(0x01)
#define TIME_OVER			(0x02)
#define CANNOT_MAKE_NODE	(0x04)
#define HUMAN_NOT_FIND      (0x08)
#define CALCULATION_ERROR    (0x10)
#define GOAL_ARRIVE_FLAG    (0x20)
#define LMC_CONNECTION_ERROR (0x40)
#define DOC_CONNECTION_ERROR (0x80)
#define WAYPOINT_DATA_LENGTH_IS_0 (0x100)
#define TURNING				(0x200)
#define TURNING_STATE		(0x400)
#define TURNING_WAYPOINT	(0x800)

//Robot Type
#define CONNECT_UnKnown_ROBOT (-1)
#define CONNECT_PeopleBot     (1)
#define CONNECT_ENON          (2)
#define CONNECT_PatraFour     (3)

//Known parameters of the robot
#define ENON_TREAD (0.410)
#define PeopleBot_TREAD (0.3325)
#define PatraFour_TREAD (0.5388)



//Output Resolution
#define DRAW_RESOLUTION (25) //A rough and large.

/** Grid Size **/
#define GRID_SIZE (50) //unitFmm

/*Cell size of the global map*/
#define G_SELL_SIZE	(10000)//mm
#define G_SELL_NUM	(G_SELL_SIZE/GRID_SIZE)//

/*** The maximum number of objects created ***/
#define OBJECT_MAX_NUM (100)

//The maximum number of people being tracked
#define MAX_TRACE_PERSON_NUM OBJECT_MAX_NUM//Up to 100 people.

/*** Maximum number of nodes ***/
#define MAXNODE (3000)//(350)
/*** Maximum number of steps (I do not want the original settings) ***/
#define MAXSTEP (1000)

#define MIN_NODE (4)  //MIN_NODE had not seen until at least where

#define REUSE_NUM_NODE (5)//7

/** Flags representing the type of object **/
#define SFLAG			(0x01) //static object
#define MFLAG			(0x02) //moving object
#define RFLAG			(0x40) //robot
#define UnKnown_FLAG	(0x80)
#define R_AvailableFLAG	(0x04)

/*** Time for a loop ***/
#ifdef __CONFIGURATION_DEFINE__
#define LoopTime    loopTime
#define TIMEOUT_SEC (timeOut_s)
#define PERIODIC_RATE (exec_Hz)
#define PERIODIC_TIME (1.0/PERIODIC_RATE)

#else
#define LoopTime	(.5)//(0.5)//s
#define TIMEOUT_SEC (70)//Grace Period Set
#endif
#define CNT			(5)//(10*LoopTime)

/*** Initial position, initial angle ***///Before the x, y right
#define XS		(0)//(1000)//(1000)//(7000)//(4000)//(-8000)//unitFmm
#define YS		(0)//(-1000)//(1000)//(5000)//(-13000)
#define TS		(0)//(0)//(90)

#define XE		(0)//(2500)//(2500)//(25000)
#define YE		(0)//(-3500)//(-5000)//(-3500)//(-8000)//(-3500)//(8000)
#define TE		(0)//(0)



/*** Designated or used to reach him ***/
#ifdef __CONFIGURATION_DEFINE__
#define GOAL_AREA (goalAreaRadius*goalAreaRadius)
#define MobjeR    (moveObjeRadius)//Radius of the moving object.
#define RR		  (robotRadius)//robot radiusFPeopleBot   
#else
#define GOAL_AREA (300*300)
#define MobjeR    (200)//(230)//(170)//(300) //Radius of the moving object. Fixed now.
#define RR		  (310)//(350)//(255)//(325)//(255) // Radius of a Robot  
#endif

/*** Some mathematical ***/
#define VERY_LARGE_INT	(0x7FFFFFFF)//Max INT type
#define R2D				(57.29577951)
#define D2R				(0.017453293)

#ifndef PI
#define PI				(3.1415926535)
#endif
#define PI_2			(1.570796)
#define PI_4			(0.785398)
#define PI2				(6.283185307) /* 2pi */

#define ROOT2			(1.41421356)

#define TRUE2			(2)

#define POW(x)			((x)*(x))

#define malloc_usable_size(a) _msize(a)

/*** Color information***/
#define GRAY	CV_RGB(128 , 128 , 128)
#define RED		CV_RGB(255 , 0   , 0)
#define BLUE	CV_RGB(0   , 0   , 255)
#define WHITE	CV_RGB(255 , 255 , 255)
#define YELLOW	CV_RGB(255 , 212 , 0)
#define ORANGE  CV_RGB(239 , 129 , 15)
#define GREEN   CV_RGB(0   , 255 ,  0)
#define BLACK   CV_RGB(0, 0, 0)

typedef struct{
	int id;
	float x;
	float y;
	float vx;
	float vy;
} RECEIVE_OBST_DATA;

typedef struct {
	float x;
	float y;
} Position;

typedef struct{
	CvPoint  local_position;
	Position pose;
	float direction;
}DUMMY_POINT;

typedef struct{
	DUMMY_POINT now;
	DUMMY_POINT next;
}DATA_LOGGER;

typedef struct{
	double x;
	double y;
	double theta;
	double v;
	double w;
	double vl;
	double vr;
}ROBOT_STATE;

#define CHECK_LM  (0)//Local Map
#define CHECK_RD  (2)//sensor data

/***** Various macro settings *****/
double direction_norm(double degree);

#endif
