// ================================================================================== //
// Name of File				: func.cpp
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#include "func.h"

void Make_LocalMap(unsigned char **LocalMap , IplImage *simulator)
{
	static int i,j;
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if(((unsigned char*)(simulator->imageData + simulator->widthStep*j))[i] > /*145*/0.6*255){//Stationary objects were
				LocalMap[i][j] = SFLAG;
			}
			else if(((unsigned char*)(simulator->imageData + simulator->widthStep*j))[i] < 0.2*255){//No area of the object
				LocalMap[i][j] = 0;
			}
			else{
				LocalMap[i][j] = UnKnown_FLAG;
			}
		}
	}
}

void CalcRobotAvailableField(unsigned char **LocalMap , int x , int y)
{
	static STACK stack;
	static CvPoint buf;
	static int Xleft , Xright;
	static int i;
	stack.init();//Stack Initialization
	stack.push(cvPoint(x,y));
	while(1){
		//3.Coordinate from a stack X, Y retrieve
		buf = stack.pop();
		if(buf.x == -1) break;//End

		/*Fill their*/
		LocalMap[buf.x][buf.y] |= R_AvailableFLAG;

		//4.(X, Y) look to the left by one pixel from the previous one as the first boundary pixel x-coordinate takes Xleft
		Xleft = buf.x;
		while((Xleft-1 >= 0) && ((LocalMap[Xleft-1][buf.y] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) ){//Should be left boundary
			Xleft--;//Move left
			/*Fill their*/
			LocalMap[Xleft][buf.y] |= R_AvailableFLAG;
		}
		//If the left boundary that contains the Xleft to urge

		//4.(X, Y) look to the right by one pixel from the previous one as the first boundary pixel x-coordinate takes Xright
		Xright = buf.x;
		while((Xright+1 < G_SELL_SIZE/GRID_SIZE) && ((LocalMap[Xright+1][buf.y] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) ){//Boundary must be right
			Xright++;
			/*Fill their*/
			LocalMap[Xright][buf.y] |= R_AvailableFLAG;
		}
		//If the right boundary Xright to urge that contains the

		//6.(Xleft, Y-1) from (Xright, Y-1) to examine one pixel at a time. This period may include a border. If it contains a border pixel coordinates of the pixel immediately before entering the inner boundary of the area (Xin, Y-1) to the stack. Xin is more in this period may have been included, all the stack those coordinates. 
		if(buf.y - 1 >= 0){
			for(i=Xleft;i<Xright;i++){
				if( ((LocalMap[i][buf.y - 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) && ((LocalMap[i+1][buf.y - 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))!=0)){//Currently there is no area of the body, and the right to object if
					stack.push(cvPoint(i,buf.y -1));
				}
			}
			//No one at the right time
			if( ((LocalMap[i][buf.y - 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) ){//If there are no objects in the current area
					stack.push(cvPoint(i,buf.y -1));
			}
		}
		//As 7.6
		if(y+1 < G_SELL_SIZE/GRID_SIZE){
			for(i=Xleft;i<Xright;i++){
				if( ((LocalMap[i][buf.y + 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) && ((LocalMap[i+1][buf.y + 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))!=0)){//Currently there is no area of the body, and the right to object if
					stack.push(cvPoint(i,buf.y + 1));
				}
			}
			//No one at the right time
			if( ((LocalMap[i][buf.y + 1] & (UnKnown_FLAG | MFLAG | SFLAG | R_AvailableFLAG))==0) ){//If there are no objects in the current area
					stack.push(cvPoint(i,buf.y + 1));
			}
		}
	}

}
void Dilation(unsigned char **LocalMap)
{
	static int i,j;
	static unsigned char tmp;
	static unsigned char LocalMap2[G_SELL_SIZE/GRID_SIZE][G_SELL_SIZE/GRID_SIZE];
	/*copy*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			LocalMap2[i][j] = LocalMap[i][j];
		}
	}

	/*Expansion*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if((tmp=LocalMap[i][j] & (SFLAG | MFLAG)) != 0){//Stationary object region, or moving object areas were expanded
				if(i>0){
					if((LocalMap[i-1][j] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i-1][j] |= tmp;
						LocalMap2[i-1][j] &= ~UnKnown_FLAG;
					}
				}
				if(j>0){
					if((LocalMap[i][j-1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i][j-1] |= tmp;
						LocalMap2[i][j-1] &= ~UnKnown_FLAG;
					}
				}
				if(i<G_SELL_SIZE/GRID_SIZE-1){
					if((LocalMap[i+1][j] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i+1][j] |= tmp;
						LocalMap2[i+1][j] &= ~UnKnown_FLAG;
					}
				}
				if(j<G_SELL_SIZE/GRID_SIZE-1){
					if((LocalMap[i][j+1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i][j+1] |= tmp;
						LocalMap2[i][j+1] &= ~UnKnown_FLAG;
					}
				}

				//8 neighborhood expansion
#if 1
				if((i>0) && (j>0)){
					if((LocalMap[i-1][j-1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i-1][j-1] |= tmp;
						LocalMap2[i-1][j-1] &= ~UnKnown_FLAG;
					}
				}
				if((j>0) && (i<G_SELL_SIZE/GRID_SIZE-1)){
					if((LocalMap[i+1][j-1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i+1][j-1] |= tmp;
						LocalMap2[i+1][j-1] &= ~UnKnown_FLAG;
					}
				}
				if((i<G_SELL_SIZE/GRID_SIZE-1) && (j<G_SELL_SIZE/GRID_SIZE-1)){
					if((LocalMap[i+1][j+1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i+1][j+1] |= tmp;
						LocalMap2[i+1][j+1] &= ~UnKnown_FLAG;
					}
				}
				if((j<G_SELL_SIZE/GRID_SIZE-1) && (i>0)){
					if((LocalMap[i-1][j+1] & RFLAG) == 0){//Region must be a robot
						LocalMap2[i-1][j+1] |= tmp;
						LocalMap2[i-1][j+1] &= ~UnKnown_FLAG;
					}
				}
#endif
			}

		}
	}

	/*copy*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			LocalMap[i][j] = LocalMap2[i][j];
		}
	}
}

#define DILATE_R2     (4)
#define DILATE_SIZE2 (DILATE_R2*2+1)
#define already_calc_flag (0x08)
unsigned char Dilation(unsigned char **LocalMap , IplImage *Gauss_f32)
{
	static bool collision_flag;
	static int i,j,s,t;
	static unsigned char tmp;
	static unsigned char LocalMap2[G_SELL_SIZE/GRID_SIZE][G_SELL_SIZE/GRID_SIZE];
	static unsigned char **mask=NULL;
	if(mask==NULL){//Mask making
		/*Partitioning*/
		mask = (unsigned char**)calloc(DILATE_SIZE2,sizeof(unsigned char *));
		for(i=0;i<DILATE_SIZE2;i++){
			mask[i] = (unsigned char *)calloc(DILATE_SIZE2,sizeof(unsigned char));
		}
		/*Create a mask image*/
		for(i=0;i<DILATE_SIZE2;i++){
			for(int j=0;j<DILATE_SIZE2;j++){
				if(POW(DILATE_R2-i)+POW(DILATE_R2-j)<=POW(DILATE_R2)){//Expansion area were
					mask[i][j] = 1;
				}
				else{
					mask[i][j] = 0;
				}
			}
		}
	}
	collision_flag = 0;//I am not in conflict.
	/*copy*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			LocalMap2[i][j] = LocalMap[i][j];
		}
	}

	/*Expansion*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){

			if((tmp=LocalMap[i][j] & (SFLAG | MFLAG)) != 0){//Stationary object region, or moving object areas were expanded
				for(s=-DILATE_R2;s<=DILATE_R2;s++){
					for(t=-DILATE_R2;t<=DILATE_R2;t++){
						if((i+s>=0)&&(i+s<G_SELL_SIZE/GRID_SIZE)&&(j+t>=0)&&(j+t<G_SELL_SIZE/GRID_SIZE)){
							if((LocalMap2[i+s][j+t] & already_calc_flag) == 0){
								if(mask[s+DILATE_R2][t+DILATE_R2] == 1){
									LocalMap2[i+s][j+t] |= already_calc_flag;
									//cvSetReal2D(Gauss_f32,i+s,j+t,cvGetReal2D(Gauss_f32,i+s,j+t)/8.0);//1/8 value
									cvSetReal2D(Gauss_f32,i+s,j+t,0.f);//1/8 value
								}
							}
						}
					}
				}
			}

		}
	}
	return (collision_flag);
}
#define DILATE_SIZE ( RR / GRID_SIZE*2+1)
unsigned char Dilation2(unsigned char **LocalMap , TREE *path,M_OBJE *obstacle[OBJECT_MAX_NUM],short NumOfMobje)
{
	static bool collision_flag;
	static int i,j,s,t;
	static unsigned char tmp;
	static unsigned char LocalMap2[G_SELL_SIZE/GRID_SIZE][G_SELL_SIZE/GRID_SIZE];
	static unsigned char **mask=NULL;
	if(mask==NULL){//Mask making
		/*Partitioning*/
		mask = (unsigned char**)calloc(DILATE_SIZE,sizeof(unsigned char *));
		for(i=0;i<DILATE_SIZE;i++){
			mask[i] = (unsigned char *)calloc(DILATE_SIZE,sizeof(unsigned char));
		}
		/*Create a mask image*/
		for(i=0;i<DILATE_SIZE;i++){
			for(int j=0;j<DILATE_SIZE;j++){
				if(POW(RR / GRID_SIZE-i)+POW(RR / GRID_SIZE-j)<=POW(RR/GRID_SIZE)){//Expansion area were
					mask[i][j] = 1;
				}
				else{
					mask[i][j] = 0;
				}
			}
		}
	}
	collision_flag = 0;//initialize to not conflict
	/*copy*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			LocalMap2[i][j] = LocalMap[i][j];
		}
	}

	/*expansion*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			if((tmp=LocalMap[i][j] & (SFLAG | MFLAG)) != 0){//Stationary object region, or moving object areas were expanded
				for(s=-RR / GRID_SIZE;s<=RR / GRID_SIZE;s++){
					for(t=-RR / GRID_SIZE;t<=RR / GRID_SIZE;t++){
						if((i+s>=0)&&(i+s<G_SELL_SIZE/GRID_SIZE)&&(j+t>=0)&&(j+t<G_SELL_SIZE/GRID_SIZE)){
							if((LocalMap2[i+s][j+t] & (SFLAG | MFLAG)) == 0){//If it is not static or dynamic object
								if((LocalMap[i+s][j+t] & RFLAG) == 0){//it's not robot area
									if(mask[s+RR / GRID_SIZE][t+RR / GRID_SIZE] == 1){
										LocalMap2[i+s][j+t] |= SFLAG;
										//LocalMap2[i+s][j+t]=0;
										LocalMap2[i+s][j+t] &= ~R_AvailableFLAG;
									}
								}else{
									//exit_robot();
									//path->velocity = 0.0;//0 the expected speed of change the next time
									printf("Dilation2:Something wrong.....Possibility of collision\n");
									collision_flag |= COLLISION;
									//cvWaitKey();
									//exit(-1);
								}
							}
						}
					}
				}
			}
		}
	}

	/*copy*/
	for(i=0;i<G_SELL_SIZE/GRID_SIZE;i++){
		for(j=0;j<G_SELL_SIZE/GRID_SIZE;j++){
			LocalMap[i][j] = LocalMap2[i][j];
		}
	}

// Check collision with moving object

float dx,dy,dr;
for(int i=0;i<NumOfMobje;i++){
dx=obstacle[i]->CPosition.x-path->pose.x;
dy=obstacle[i]->CPosition.y-path->pose.y;
dr=sqrt(POW(dx)+POW(dy));
//if(dr<2*MobjeR && obstacle[i]->velocity<=15.0)collision_flag|=COLLISION;
if(dr<2*MobjeR)collision_flag|=COLLISION;
}


	return (collision_flag);
}

