// ================================================================================== //
// Name of File				: motion_set.cpp
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#include <stdio.h>
#include <stdlib.h>
#include "motion_set.h"

//#define __DEBUG__

MOTION_CONTROL::MOTION_CONTROL(){
	//The constructor does nothing
	//this->read();
}

MOTION_CONTROL::~MOTION_CONTROL(){
	this->destroy();
}

void MOTION_CONTROL::read(){
	//Read the motion data
	FILE *fp;
	fopen_s(&fp, MOTION_DEF_FILE_NAME, "rb");
	if(fp == NULL){
		printf("ERROR : motion data file (%s) is nothing. exit.\n", MOTION_DEF_FILE_NAME);
		getchar();
		exit(-1);
	}
	fread(&(data.motion_num), sizeof(int), 1, fp);
#if 1//__DEBUG__
	//printf("motion_num = %d\n", data.motion_num);
#endif
	data.r_v = (RV_SET *)calloc(data.motion_num, sizeof(RV_SET));
	data.vl_vr = (VL_VR_SET *)calloc(data.motion_num, sizeof(VL_VR_SET));
	fread(data.r_v, sizeof(RV_SET), data.motion_num, fp);
	fread(data.vl_vr, sizeof(VL_VR_SET), data.motion_num, fp);
	fclose(fp);
#ifdef __DEBUG__
	for(int i=0;i<data.motion_num;i++){
		printf("[%d]:r=%.2f\tv=%.2f\tvr=%.2f\tvl=%.2f\n",i+1, data.r_v[i].radius, data.r_v[i].velocity, data.vl_vr[i].vr, data.vl_vr[i].vl);
	}
#endif
	return;
}

void MOTION_CONTROL::read(std::string fileName){
	//Read the motion data
	FILE *fp;
	fopen_s(&fp, fileName.c_str(), "rb");
	if(fp == NULL){
		printf("ERROR : motion data file (%s) is nothing. exit.\n", fileName.c_str());
		getchar();
		exit(-1);
	}
	fread(&(data.motion_num), sizeof(int), 1, fp);
#if 1//__DEBUG__
	//printf("motion_num = %d\n", data.motion_num);
#endif
	data.r_v = (RV_SET *)calloc(data.motion_num, sizeof(RV_SET));
	data.vl_vr = (VL_VR_SET *)calloc(data.motion_num, sizeof(VL_VR_SET));
	fread(data.r_v, sizeof(RV_SET), data.motion_num, fp);
	fread(data.vl_vr, sizeof(VL_VR_SET), data.motion_num, fp);
	fclose(fp);
#ifdef __DEBUG__
	for(int i=0;i<data.motion_num;i++){
		printf("[%d]:r=%.2f\tv=%.2f\tvr=%.2f\tvl=%.2f\n",i+1, data.r_v[i].radius, data.r_v[i].velocity, data.vl_vr[i].vr, data.vl_vr[i].vl);
	}
#endif
	return;
}

void MOTION_CONTROL::destroy(){
	data.motion_num = 0;
	free(data.r_v);
	free(data.vl_vr);
}