// ================================================================================== //
// Name of File				: tree_new.h
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#ifndef TREE_NEW_H
#define TREE_NEW_H

#include "base_data.h"
#include "obst_info.h"
#include "motion_set.h"
//#include <opencv/cv.h>
//#include <opencv/cxcore.h>
//#include <opencv/highgui.h>
#include <vector>

typedef struct{
	unsigned short parent;
	float radius , velocity , time;
	char vector;
	float density;
	Position pose;
	CvPoint local_pose;
	float direction;
} TREE;

//#define RRT_ONLY

unsigned char Check_Arrive(TREE *path, int step, float *xg, float *distances, float threshold);//Checks if robot bas been arrived at the goal
int InitState(TREE *tree , int maxnode);
int build_path(TREE *tree,TREE *path,int closest_node,int step);//construct path founded by tree
void save_path_for_next_use(TREE *path,TREE *tree,int step,int path_depth);
bool reuse_prevoius_path(unsigned char **LocalMap,IplImage *gauss_f32,TREE *tree,M_OBJE *obstacle[OBJECT_MAX_NUM],R_OBJE *robot ,DATA_LOGGER robot_data,int path_depth,short NumOfMobje);
int search_close_node(IplImage *gauss_f32,IplImage *dt_f32,TREE *tree,DATA_LOGGER robot_data,Position goal,int num_node);//search which node that tend to be nearest to the goal
int make_tree(unsigned char **LocalMap,IplImage *gauss_f32,IplImage *dt_f32,TREE *tree,Position goal,R_OBJE *robot,DATA_LOGGER robot_data,MOTION_CONTROL *motion,M_OBJE *obstacle[OBJECT_MAX_NUM],unsigned short *warning_flag,short NumOfMobje,bool flag_reuse,int path_depth);// New Randomize method search
int make_tree_best(unsigned char **LocalMap,IplImage *gauss_f32,IplImage *dt_f32,TREE *tree,Position goal,R_OBJE *robot,DATA_LOGGER robot_data,MOTION_CONTROL *motion,M_OBJE *obstacle[OBJECT_MAX_NUM],unsigned short *warning_flag,short NumOfMobje,bool flag_reuse,int path_depth);// Best path search
unsigned char quadran(IplImage *gauss_f32);

#endif