#include "StateMachine.h"
#include "../rtcutil/rtcutil.h"
#include "smutil.h"


using namespace std;


/**********************************************************
	
**********************************************************/
int StateMachine::initializeStateMachineAndHTTPC(
	const char *xml_path, unsigned short tcp_port )
{

	if( state_machine.initialize( xml_path ) )
		return -1;

	state_machine.print();

	if( httpc.initialize( tcp_port, "templ.html" ) )
		return -2;

	// ԂHTNLɃZbg
	const string &state = state_machine.getCurrentState().getName();
	const vector< state_machine::StateMachine::State::transition_t >
		&trans_tbl = state_machine.getCurrentState().getTransitionTable();

	next_status.clear();
	disabled_status.clear();

	std::vector< state_machine::StateMachine::State::transition_t >::
		const_iterator cit;
	for( cit = trans_tbl.begin(); cit != trans_tbl.end(); ++ cit ) {
		next_status.push_back( cit->next->getName() );
		// Ԃ̑Jڂ͋IɃ{^ŊJn邽߂ɗLĂ
		disabled_status.push_back( false );
	}
	httpc.setHTMLParameter( state, next_status, disabled_status );

	return 0;
}


/**********************************************************
	I
**********************************************************/
int StateMachine::finalizeStateMachineAndHTTPC()
{
	
	httpc.finalize();
	state_machine.finalize();

	return 0;
}


/**********************************************************
	
**********************************************************/
int StateMachine::process()
{
	bool in_transition = false, error = false, on_auto = false;
	
	if( m_inputIn.isNew() ) {
		/* ԋ@Bւ̓͂ꍇ */
		m_inputIn.read();

		input = m_input.data[0];

		// IvV(m_input.data[1]ȍ~)̕ۑKvȂ͂
		// CPOST҂̂ƂɕʂPOST΁C
		// ɉIvVKp邽߂ɁC
		// ̃IvVZbgێEǗKv͂

		cout << "i:" << input << "@" << state_machine.getCurrentStateName() << endl;

		int idx = state_machine.isNextStateFound( input );
		if( idx != -1 ) {
			/* Ԃ͕gJڂꍇ */
			
			if( state_machine.getTransitionTable().at(idx).on_manual ) {
				// Jڃ^C~O蓮̏ꍇ̓{^̗L
				disabled_status.at(idx) = false;
				httpc.setHTMLParameter(
					state_machine.getCurrentStateName(),
					next_status, disabled_status );
				httpc.push();
					// ̏ꍇ͑Jڂ͂ɁC{^ɂPOST҂
			}
			else {
				// Jڂ̏ꍇ͑J
				output = state_machine.getTransitionTable().at(idx).output;
				in_transition = on_auto = true;
			}
		}
		else {
			/* `̓͂̏ꍇCG[Ԃ */
			cout
				<< "Transition from state '"
				<< state_machine.getCurrentState().getName() 
				<< "' with input '" << input << "' not found. "
				<< endl;
		
			// G[Ԃ~RTCXgĂΏRTC~
			//killRTCs( state_machine.getCurrentState().getError() );

			input = output = "";
			in_transition = error = on_auto = true;
		}

	}

	/* HTTP POST ̃`FbN */
	// httpc݂POST2ނ
	// @{^ɂPOSTCAstate-query
	// waitForPOST̓{^ɂPOST
	if( httpc.waitForPOST() ) {
		/* Ԗ`FbN */
		// POSTꂽf[^̎ԕv͂擾
		string posted_data;
		httpc.getPostedData( posted_data );

		const size_t eq_pos = posted_data.find_first_of( "=" );

		const string &posted_curr = posted_data.substr( 0, eq_pos );
		string posted_next = posted_data.substr( eq_pos+1 );
		
		/*
		cout
			<< "(" << posted_curr << ")"
			<< "(" << state_machine.getCurrentState().getName() << ")"
			<< "<" << posted_next << ">"
			<< endl;
		*/
#		if 0
		// Ԃ瑗ꂽPOSTȂJڂɕKvȓ͂𒲂ׂ
		// قȂԂ瑗ꂽPOST̓G[ (Mar.11.2012)
		if( curr_in_posted != state_machine.getCurrentState().getName()
			|| next_in_posted == "Abort" ) {
#		else
		// Ԃ瑗ꂽPOSTȂJڂɕKvȓ͂𒲂ׂ
		// قȂԂ瑗ꂽPOST͖ (Mar.11.2012)
		if( posted_curr != state_machine.getCurrentState().getName() ) {
			cout
				<< "State confliction: "
				<< "current state FSM: " << state_machine.getCurrentState().getName()
				<< "/ posted: " << posted_curr << endl;
			httpc.postDataUpdated();
				// f[^XVƌ
		}
		else if( posted_next == "Abort" ) {
#		endif
			input = output = "";
			in_transition = error = true;

			// G[Ԃ~RTCXgĂΏRTC~
			//killRTCs( state_machine.getCurrentState().getError() );

			// POST ̏ꍇ on_auto = true; ͂Ȃ
			// POST ̂NGXgȂ̂ŁCX|X͕Ԃ
		}
		else {
			int idx = state_machine.getRequiredInput(
				posted_next, input );
			//cout << idx << " " << next_in_posted << endl;
			if( idx == -1 )
				input = "";
					// ԕsv̏ꍇɂ̓G[

			output = state_machine.getTransitionTable().at(idx).output;

			// v͂𗘗pĎԂ֏ԑJ
			in_transition = true;
		}
	}


	if( in_transition ) {
		// ԑJڂKvȏꍇ͑J
		if( error )	state_machine.transitionIntoError();
		else				state_machine.transition( input );

		// ̎_ŊɌԂ́uvԂւƑJڍς

		// Ԃ~RTCXgĂΏRTC~
		killRTCs( &state_machine.getCurrentState() );

		// Ԃ̏񂩂HTML𐶐CPOST̃X|XƂđM
		const string &state = state_machine.getCurrentStateName();
		next_status.clear();
		disabled_status.clear();

		const vector< state_machine::StateMachine::State::transition_t > 
			&trans_tbl = state_machine.getCurrentState().getTransitionTable();
		std::vector< state_machine::StateMachine::State::transition_t >::
			const_iterator cit;
		for( cit = trans_tbl.begin(); cit != trans_tbl.end(); ++ cit ) {

			next_status.push_back( cit->next->getName() );

			//disabled_status.push_back( cit->on_manual && cit->input != "" );
			// {^ꍇ
			//	蓮 && ͂̂
			//	 && ͂̂
			disabled_status.push_back( cit->input != "" );
		}

		httpc.setHTMLParameter( state, next_status, disabled_status );
		httpc.postDataUpdated();

		cout << "o:"<< output << "@" << state_machine.getCurrentStateName() << "(transitioned)" << endl;

		// Jڏo
		if( !error )
			smutil::write( output, m_output, m_outputOut );
	}

	// Jڂ̏ꍇ̓vbVM
	if( on_auto )
		httpc.push();

	return 0;
}


/**********************************************************
	G[Ԏɒ~XgRTC~
**********************************************************/
bool StateMachine::killRTCs( const state_machine::StateMachine::State *error )
{
	if( !error || !error->getRTCsKilledOnError().size() ) return false;
	
	rtcutil::RTShell rtshell;
	rtshell.setNameServers( state_machine.getNameServers() );

	bool rc = true;
	
	vector< string >::const_iterator cit;
	const vector< string > &kill_list = error->getRTCsKilledOnError();
	cerr << ">> StateMachine::killRTCs()" << endl;
	for( cit = kill_list.begin(); cit != kill_list.end(); ++ cit ) {
		cerr << "Killing " << cit->c_str() << "..." << endl;
		if( rtshell.exit( cit->c_str() ) ) {
			rc = false;
			cerr << " [Failed]" << endl;
		}
		else
			cerr << " [  OK  ]" << endl;
	}
	cerr << "<< StateMachine::killRTCs()" << endl;

	return rc;
	
}