/**********************************************************/
/* OpenCV Wrapper																					*/
/*	@ Author				:	J. Sugiyama @ AISL.TUT							*/
/*	@	Last update		:	01.Feb.2012													*/
/**********************************************************/
#pragma once


#include <opencv/cv.h>


namespace opencv
{
namespace cvmath
{

	/*=======================================================
		s̗vf^
	=======================================================*/
	namespace CVElem {
		template <int>	struct CvElemTypeTraits;
		template <>			struct CvElemTypeTraits< CV_32F > { typedef float						ElemType; };
		template <>			struct CvElemTypeTraits< CV_64F > { typedef double					ElemType; };
		template <>			struct CvElemTypeTraits< CV_8U  > { typedef unsigned char		ElemType; };
		template <>			struct CvElemTypeTraits< CV_8S  > { typedef char						ElemType; };
		template <>			struct CvElemTypeTraits< CV_16U > { typedef unsigned short	ElemType; };
		template <>			struct CvElemTypeTraits< CV_16S > { typedef short						ElemType; };
		template <>			struct CvElemTypeTraits< CV_32S > { typedef long						ElemType; };
	}

} // namespace cvmath
} // namespace opencv