#include "cvutil.h"
//#include "../../Image/Image/Image.h"
#include <iostream>


static const int W = 640, H = 480;


int main()
{
#if 1
	//opencv::cvutil::Image<IPL_DEPTH_8U> dst(10, 10, 1), src(10, 10, 1);
	opencv::cvutil::Image<IPL_DEPTH_32F> dst(10, 10, 1), src(10, 10, 1);
	src.clear();

	for ( int v = 0; v < src.getHeight(); ++v ) {
		for ( int u = 0; u < src.getWidth(); ++u ) {
			src(u, v) = u + v;
		}
	}
	
	dst.clear();
	dst.copy(src, 3, 3, 2, 5, 4, 3);

	printf("src\n");
	for ( int v = 0; v < src.getHeight(); ++v ) {
		for ( int u = 0; u < src.getWidth(); ++u ) {
			std::cout << src(u, v) << " ";
		}
		printf("\n");
	}

	printf("dst\n");
	for ( int v = 0; v < dst.getHeight(); ++v ) {
		for ( int u = 0; u < dst.getWidth(); ++u ) {
			std::cout << dst(u, v) << " ";
		}
		printf("\n");
	}
	printf("\n");
	std::cout << dst.NW(3,6) << " " << dst.N(3,6) << " " << dst.NE(3,6) << std::endl;
	std::cout << dst. W(3,6) << " " << dst  (3,6) << " " << dst. E(3,6) << std::endl;
	std::cout << dst.SW(3,6) << " " << dst.S(3,6) << " " << dst.SE(3,6) << std::endl;
	getchar();

#endif

#if 0
	opencv::cvutil::Window win( "Capture" );
	win.open();

	opencv::cvutil::Camera cam;
	cam.initialize(W, H, 0);

	opencv::cvutil::Image<IPL_DEPTH_8U> frm(W, H, 3);
	
	while(win.isAlive()){
		frm.copy(cam.query());
		win.display(frm);
		win.wait(10);
	}
	
#endif

#if 0
	opencv::cvutil::Image<IPL_DEPTH_8U> frm(W, H, 3), hsv(W, H, 3), hue(W, H, 1);
	
#if 0
	frm.clear();
	for(int v = 0; v < frm.getHeight(); v ++)
		for(int u = 0; u < frm.getWidth(); u ++)
			frm(u, v, 0, v,	frm(u, v, 1, v,	frm(u, v, 2, v;
	
	frm.show("test");	cvWaitKey();	getchar();
#endif

	opencv::cvutil::Image<IPL_DEPTH_8U> frm_buf[1000];
	
	for(int i = 0; i < 1000; i ++)
		frm_buf[i].create(W, H, 3);

	int frm_i_to_be_used;
	win.wait(10000);
	for(frm_i_to_be_used = 0; win.isAlive() && frm_i_to_be_used < 1000; frm_i_to_be_used ++){
		frm_buf[frm_i_to_be_used].copy(cam.query());
		win.display(frm_buf[frm_i_to_be_used]);
		win.wait(50);
	}

	char name[128];
	for(frm_i_to_be_used --; frm_i_to_be_used >= 0; frm_i_to_be_used --){
		sprintf_s(name, 128, "Frames/%04d.png", frm_i_to_be_used);
		frm_buf[frm_i_to_be_used].save(name);
	}

#if 0
	while(win.isAlive()){
		frm.copy(cam.query());
		frm.convert(hsv, CV_BGR2HSV);
		hue.copyChannel(hsv, 0, 0);

		win.display(hue);
		win.wait(10);
	}
#endif

#endif

#if 1
	opencv::cvutil::Image<IPL_DEPTH_8U> *img, diff(W, H, 3);

	opencv::cvutil::Camera cam;
	cam.initialize(W, H, 0);

	opencv::cvutil::Window win( "Capture" );
	win.open();

	img = new opencv::cvutil::Image<IPL_DEPTH_8U> [2];
	img[0].create(W, H, 3);
	img[1].create(W, H, 3);

	int i = 0;
	img[0].copy(cam.query());
	img[1].copy(cam.query());
	while(win.isAlive()){
		i = (i+1)%2;

		img[i].copy(cam.query());

		cvSub(img[i], img[(i+1)%2], diff);

		win.display(diff);

		win.wait(20);
	}

	delete [] img;
#endif

	return 0;
}