#if 0
#define _USE_MATH_DEFINES
#include <cmath>
#include "socket.h"

double htond(double host_order)
{
	unsigned char *ptr = (unsigned char *) &host_order, temp;
	temp = ptr[0], ptr[0] = ptr[7], ptr[7] = temp;
	temp = ptr[1], ptr[1] = ptr[6], ptr[6] = temp;
	temp = ptr[2], ptr[2] = ptr[5], ptr[5] = temp;
	temp = ptr[3], ptr[3] = ptr[4], ptr[4] = temp;
	return host_order;
}


double ntohd(double network_order)
{
	unsigned char *ptr = (unsigned char *) &network_order, temp;
	temp = ptr[0], ptr[0] = ptr[7], ptr[7] = temp;
	temp = ptr[1], ptr[1] = ptr[6], ptr[6] = temp;
	temp = ptr[2], ptr[2] = ptr[5], ptr[5] = temp;
	temp = ptr[3], ptr[3] = ptr[4], ptr[4] = temp;
	return network_order;
}


double rad2deg(double rad){	return rad * 180 / M_PI; }
double deg2rad(double deg){	return deg * M_PI / 180; }


typedef struct SEND_PACKET_TYPE
{
	char buf[sizeof(int)*1+sizeof(double)*23+sizeof(int)*1];
		
public:
	int *getCmdId(){	return (int *) &buf[0];	}
	double *getAngles(){	return (double *) &buf[sizeof(int)*1];	}
	double *getPose(){	return (double *) &buf[sizeof(int)*1];	}
	int *getTime(){	return (int *) &buf[sizeof(int)*1+sizeof(double)*23];	}

	void setCmdId(int id)	{	*getCmdId() = htonl(id);	}
	void setAngles(double *angles){
		for(int i = 0; i < 23; ++ i)
			setAngle(i, angles[i]);
	}
	void setAngle(int idx, double angle)	{ getAngles()[idx] = htond(angle);	}
	void setPose(int idx, double pose)	{ getAngles()[idx] = htond(pose);	}
	void setTime(int tm)	{	*getTime() = htonl(tm);	}
} send_packet_t;


typedef struct RECEIVE_PACKET_TYPE
{
	char buf[sizeof(int)*1+sizeof(double)*23];
public:
	int getCmdId(){	return ntohl(*((int *) &buf[0]));	}
	//const double *getAngles() const {	return (double *) &buf[sizeof(int)*1];	}
	double getAngle(int idx) const {	return ntohd(((double *) &buf[sizeof(int)*1])[idx]);	}
	double getPose(int idx) const {	return ntohd(((double *) &buf[sizeof(int)*1])[idx]);	}
} receive_packet_t;

int main()
{
	sys::SocketBase::initializeWinSock();
	
	sys::TCPSocket to_server;

	//to_server.setServerAddressINet("10.254.3.2", 54314);
	to_server.setServerAddressINet("localhost", 54314);
	to_server.open();
	to_server.connect();

	send_packet_t send_packet;
	receive_packet_t recv_packet;

	int byte;
	
#if 1
	// getState
	send_packet.setCmdId(101);	// sbuf[0] = htonl(101);
	byte = to_server.send(send_packet.buf, sizeof(int));
	byte = to_server.recv(recv_packet.buf, sizeof(recv_packet.buf));

	printf("CmdId: %d/%d\n", ntohl(*send_packet.getCmdId()), recv_packet.getCmdId());
	for(size_t i = 0; i < 23; ++ i){
		printf("%f ", rad2deg(recv_packet.getAngle(i)));

		switch(i){
		case 2:
		case 8:
		case 14:
		case 18:
		case 22: putchar('\n');
		default: break;
		}
	}

	getchar();
#endif

#if 1
	// setJointAnglesDeg
	send_packet.setCmdId(70);
	for(int i = 0; i < 23; ++ i)
		send_packet.setAngle(i, rad2deg(recv_packet.getAngle(i)));
	send_packet.setAngle(18, -45);
	send_packet.setTime(1);

	byte = to_server.send(send_packet.buf, sizeof(send_packet.buf));
	byte = to_server.recv(recv_packet.buf, sizeof(recv_packet.buf));
	printf("CmdId: %d/%d\n", ntohl(*send_packet.getCmdId()), recv_packet.getCmdId());
	getchar();
#endif

#if 1
	// getCurrentConfigurationR
	send_packet.setCmdId(50);	
	byte = to_server.send(send_packet.buf, sizeof(int));
	byte = to_server.recv(recv_packet.buf, sizeof(recv_packet.buf));

	printf("CmdId: %d/%d\n", ntohl(*send_packet.getCmdId()), recv_packet.getCmdId());
	for(size_t i = 0; i < 6; ++ i){
		printf("%f ", recv_packet.getPose(i));
	}

	getchar();
#endif

#if 1
	// moveR
	send_packet.setCmdId(51);
	memset(send_packet.getPose(), 0, sizeof(double) * 6);
	send_packet.setPose(0, recv_packet.getPose(0));
	send_packet.setPose(1, recv_packet.getPose(1)-0.1);
	send_packet.setPose(2, recv_packet.getPose(2));
	send_packet.setPose(3, recv_packet.getPose(3));
	send_packet.setPose(4, recv_packet.getPose(4));
	send_packet.setPose(5, recv_packet.getPose(5));
	byte = to_server.send(send_packet.buf, sizeof(int)+sizeof(double) * 6);
	byte = to_server.recv(recv_packet.buf, sizeof(recv_packet.buf));

	printf("CmdId: %d/%d\n", ntohl(*send_packet.getCmdId()), recv_packet.getCmdId());

	getchar();
#endif

	to_server.close();

	return 0;
}

#else

#include "../../hiro/packet/hiro-packet.h"

int main()
{
	hiro::Packet cmd, res;

	sys::SocketBase::initializeWinSock();
	sys::TCPSocket to_server;

	to_server.setAddressINet("10.254.3.2", 54314);
	//to_server.setAddressINet("localhost", 54314);
	to_server.open();
	to_server.connect();

	int byte;
	
#if 1
	// goWatchingPose
	cmd.setCommandID(hiro::Packet::GO_WATCHINGPOSE);

	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int));

	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());

	getchar();
#endif

	#if 1
	// goPickingPose
	cmd.setCommandID(hiro::Packet::GO_PICKINGPOSE);

	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int));

	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());

	getchar();
#endif

#if 1
	// getState
	cmd.setCommandID(hiro::Packet::GET_STATE);	// sbuf[0] = htonl(101);
	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int)+sizeof(double)*23);

	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());
	for(size_t i = 0; i < 23; ++ i){
		printf("%f ", res.getAngle(i));

		switch(i){
		case 2:
		case 8:
		case 14:
		case 18:
		case 22: putchar('\n');
		default: break;
		}
	}

	getchar();
#endif

#if 1
	// setJointAnglesDeg
	cmd.setCommandID(hiro::Packet::SET_JOINT_ANGLES_RAD);
	for(int i = 0; i < 23; ++ i)
		cmd.setAngle(i, res.getAngle(i));
	cmd.setAngle(18, -45);
	cmd.setTime(0.2);

	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int));
	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());
	getchar();
#endif

#if 1
	// getCurrentConfigurationR
	cmd.setCommandID(hiro::Packet::GET_CURRENT_CONFIGURATION_R);	
	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int) + sizeof(double)*6);

	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());
	for(size_t i = 0; i < 6; ++ i){
		printf("%f ", res.getPose(i));
	}

	getchar();
#endif

#if 1
	// moveR
	cmd.setCommandID(hiro::Packet::MOVE_R);
	cmd.setPose(0, res.getPose(0));
	cmd.setPose(1, res.getPose(1)-1);
	cmd.setPose(2, res.getPose(2));
	cmd.setPose(3, res.getPose(3));
	cmd.setPose(4, res.getPose(4));
	cmd.setPose(5, res.getPose(5));
	cmd.setRate(30);
	byte = to_server.send(cmd.getPacket(), cmd.getByteSize());
	byte = to_server.recv(res.getPacket(), sizeof(int));

	printf("CmdId: %d/%d\n", cmd.getCommandId(), res.getCommandId());

	getchar();
#endif

	to_server.close();

	return 0;
}

#endif